# Development wiki

## Complex documentation topics and how-to's

(with covered contents and rate to which the topic is covered in brackets)
* [Command line usage](Command-line-usage)
* [Cross-diagram references](Cross-diagram-references)
* [MVC](MVC)
* [Commands](Commands)
	* CommandBase,  
	* StackedCommandBase, IStackedCommandBase
	* UndoStack, RedoStack, UndoCommand, RedoCommand
	* Model and diagram commands
	* Command inheritance diagram
	* HOW-TO create a command
* [Controllers](Controllers)
	* Controller, DiagramController, ModelController
	* Controller inheritance diagram
* [Command factories](Command-factories)
	* Factory inheritance diagram
* [Binding](Binding) (not covered)
* [ViewHelpers](ViewHelpers)
	* Viewhelper inheritance diagram
* [Representing elements of diagrams](Representing-elements-of-diagrams) (80% covered)
	* XCaseCanvas
	* IModelRepresentant, Registrations
	* Binding, ViewPropertyBinding, ModelPropertyBinding
* [XCase drawing framework](XCase-drawing-framework) (not covered)
	* Elements
		* DragThumb, ConnectableDragThumb, ResizeThumb, Templates
	* Junctions
		* IConnectable, ISnapPointHookProvider, 
		* XCaseJunction, XCaseSimpleJunction, SnapPointHook
* [Setup](Setup)