**Summary**

XCase is a case tool for conceptual modeling of XML data based on MDA as it separates the conceptual modeling process to two levels: Platform-Independent and Platform-Specific Model. From each PSM diagram you can derive an XML schema describing a data view.

Theoretical background: [http://www.ksi.mff.cuni.cz/xcase/](http://www.ksi.mff.cuni.cz/xcase/)

### Check out [release:44785](release_44785)

#### New features: 

* adding and removing classes in existing associations
* ability to duplicate existing diagrams
* xs:anyAttribute support in PSM Classes
* copy and paste (limited to a scope of one project) 
* ability to have more than one version of a project. 
* more advanced docking library component

#### Known issues
* more dockable content in one pane show no header in tabs

**Download [release:26153](release_26153)**

**Detailed project description**

XCase is based on Model-Driven Architecture (MDA). Applying XCase, you first model a schema in a Platform-Independent Model (PIM) where you provide an XML-independent conceptual description of your problem domain. On the base of the PIM schema you model one or more schemes in a Platform-Specific Model (PSM) where you specify how your data is to be represented in concrete types of XML documents. XCase applies the well-known model of UML class diagrams as PIM and a little augmentation of this model as PSM.

Applying MDA in an advanced way, XCase greatly facilitates not only the design but maintenance of the XML schemes in your system as well. We therefore believe that it will be helpful to a broad range of analysts and designers who somehow deal with XML data. For further information, please see data sheets, comparison with other XML data modeling tools and screenshots.

Please take into account that XCase is, in its current state, an academic experiment. Its main purpose is to test some novel ideas of applying MDA for XML data modeling in a more advanced way compared to current approaches. The implemented PSM model has been developed on a theoretical level and XCase should be its proof-of-concept. Therefore, we provide XCase freely for any use and we are looking forward to receive any comments, suggestions, practical experience, and compliments from the community.

* Introduction to XCase in Czech: [http://blog.jakubmaly.cz/programovani/software/xcase-released.aspx](http://blog.jakubmaly.cz/programovani/software/xcase-released.aspx)

**[Development wiki](Development-wiki)**